<script>
// import { ValidationObserver, ValidationProvider } from 'vee-validate'
// import {
//   BAlert, BButton, BCol, BForm, BFormGroup, BFormInput, BRow, BSpinner,
// } from 'bootstrap-vue'
// import { required } from '@validations'
import MsnApiV1 from '@/api/msnApi';

export default {
  name: 'NewSubscriberForm',
  components: {
    ValidationProvider,
    ValidationObserver,
    BAlert,
    BForm,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BButton,
    BSpinner,
  },
  data() {
    return {
      subscriber: { name: '', userId: '', description: '' },
      required,
      saving: false,
      isRequest: false,
      isError: false,
      requestMessage: '',
    }
  },
  computed: {
    alertToggleVariant() {
      return this.isError ? 'danger' : 'success'
    },
    alertToggleText() {
      return this.isError ? 'Error!' : 'Success!'
    },
  },
  mounted() {
    this.$refs.newSubscriberForm.reset()
  },
  methods: {
    async validationForm() {
      const success = await this.$refs.simpleRules.validate()
      if (success)
        await this.saveSubscriber()
    },
    async saveSubscriber() {
      this.saving = true
      console.log('this.subscriberData: ', this.subscriber)

      const subscribers = new MsnApiV1()
      try {
        const response = await subscribers
          .createSubscriber(this.subscriber.name, this.subscriber.userId, this.subscriber.description)

        this.subscriber = response.data.data
        console.log('responseSubscriberData: ', JSON.parse(JSON.stringify(this.subscriber)))
        this.requestMessage = response.data.message
        this.isError = false
      }
      catch (error) {
        console.log('error saveSubscriber', error)
        this.requestMessage = error.response.data.message
        this.isError = true
      }
      this.saving = false
      this.isRequest = true
    },
  },
}
</script>

<template>
  <ValidationObserver ref="simpleRules">
    <BForm
      ref="newSubscriberForm"
      class="mt-2"
    >
      <BRow>
        <BCol md="6">
          <BFormGroup
            label="Subscriber Name"
            label-for="name"
          >
            <ValidationProvider
              v-slot="{ errors }"
              name="Subscribername"
              rules="required"
            >
              <BFormInput
                v-model="subscriber.name"
                :state="errors.length > 0 ? false : null"
                placeholder="Subscriber name"
                autocomplete="off"
              />
              <small class="text-danger">{{ errors[0] }}</small>
            </ValidationProvider>
          </BFormGroup>
        </BCol>
        <!-- /*TODO, Sacar listado de ID, a partir de listado de nombres de usuario , como autocomplete */ -->
        <BCol md="6">
          <BFormGroup
            label="SubscriberUserId"
            label-for="user_id"
          >
            <BFormInput
              v-model="subscriber.user_id"
              placeholder="Subscriber User Id"
              autocomplete="off"
            />
          </BFormGroup>
        </BCol>
        <BCol md="12">
          <BAlert
            v-if="isRequest"
            :variant="alertToggleVariant"
            show
          >
            <div class="alert-body">
              <FeatherIcon
                icon="InfoIcon"
                class="mr-50"
              />
              <span><strong>{{ alertToggleText }}</strong> {{ requestMessage }}.</span>
            </div>
          </BAlert>
        </BCol>
        <BCol cols="12">
          <BButton
            variant="primary"
            class="mt-2 mr-1"
            :disabled="saving"
            @click="validationForm"
          >
            <BSpinner
              v-if="saving"
              small
            />
            <span v-if="saving"> Saving... </span>
            <span v-else> Save changes </span>
          </BButton>
          <BButton
            type="reset"
            variant="outline-secondary"
            class="mt-2 mr-1"
          >
            Reset
          </BButton>
        </BCol>
      </BRow>
    </BForm>
  </ValidationObserver>
</template>

<style scoped>

</style>
